#grt4p.tcl---GRT 4P module control frame


set frame
set frametitle "GRT 4P Module Setup & Monitor"
set icontitle "GRT4P"

set modulename  grt4p
set moduletype  "grt4p"

loadsource common.vme

get-module-configuration

set module 1
set channel "A"

set allmodules 0
set allchannels 0

set ViewMode 0    ;#  user

#    widget => register for expert view
foreach ch {A B C D} {
  set w2r(DPP[set ch]CSR) Ch$ch.DPP_CSR
  set w2r(DPP[set ch]WPTR) Ch$ch.DPP_Wptr
  set w2r(DPP[set ch]RPTR) Ch$ch.DPP_Rptr
  for {set i 4} {$i <= 6} {incr i} {
    set w2r(DPP$ch$i) Ch$ch.DPP_Reg$i
  }
}

#    widget => register for user view
set w2r(DPPCSR)  DPP_CSR
set w2r(DPPWPTR) DPP_Wptr
set w2r(DPPRPTR) DPP_Rptr
set w2r(DPP4)    DPP_Reg4
set w2r(DPP4)    DPP_Reg5
set w2r(DPP4)    DPP_Reg6

#    widget => register for expert view
foreach ch {A B C D} {
  set w2r(ADC[set ch]PRETRIG) Ch$ch.ADC_PreTrig
  set w2r(ADC[set ch]HEADER)  Ch$ch.ADC_Header
  set w2r(ADC[set ch]TRIGGER) Ch$ch.ADC_Trigger
  set w2r(ADC[set ch]CTRL)    Ch$ch.ADC_Ctrl
  set w2r(ADC[set ch]ADCVERSION)   Ch$ch.ADC_Spare3
  set w2r(ADC[set ch]CFDTHRESH)    Ch$ch.ADC_CFDThresh
}

#    widget => register for user view
set w2r(ADCPRETRIG)    ADC_PreTrig
set w2r(ADCHEADER)     ADC_Header
set w2r(ADCTRIGGER)    ADC_Trigger
set w2r(ADCCTRL)       ADC_Ctrl
set w2r(ADCADCVERSION) ADC_Spare3
set w2r(ADCCFDTHRESH)  ADC_CFDThresh


proc click-select-module {v} {
    global module
    set module $v
    click-redisplay
}

proc click-select-channel {v} {
    global channel
    set channel [lindex [list A B C D] $v]
    click-redisplay
}
  
proc click-software {} {
   global modulename
   inform [set modulename]sftwre start
}

proc click-registers {} {}

proc click-widget {w v} {
    global ViewMode w2r
    global modulename module
    global allmodules allchannels
    global CurrentVMEServer
    global channel

    if {$ViewMode == 0} {
        set register Ch$channel.$w2r($w)
    } else {
        set register $w2r($w)
    }

    if {$allchannels == 1} then {set register [string range $register 0 1]?[string range $register 3 end]}
    set value $v

    if {$allmodules == 0} then {
        write-vme-registers $modulename#$module.$register $value
    } else {
        set CurrentVMEServer [inform vmecontrol inquire Role]
        write-vme-registers $modulename#\[?,??\].$register $value
        set CurrentVMEServer [inform vmecontrol VMEmodule2server $modulename#$module]
    }

    click-redisplay
}

proc read_fifo {ch} {
    global modulename module
    global EGallow

    set register "Ch$ch.DataFiFo"
    set EGallow 0x2000a
    set value [read-vme-register $modulename#$module.$register]
    set EGallow 0xffffffff
    if {$value == 0x2000a} then {set value "BERR"}
    :modify DATA$ch :value $value
}

proc click-inuse {vl} {
    global ViewMode modulename module channel

    set value [read-vme-register $modulename#$module.Ch$channel.DPP_CSR]
    
    write-vme-registers $modulename#$module.Ch$channel.DPP_CSR [expr ($value & 0xff7f) | ((!$vl & 1) << 7)]

       if {$ViewMode == 0} then {set CH ""} else {set CH $channel}

        set value [read-vme-register $modulename#$module.Ch$channel.DPP_CSR]
        if {$value == 0x2000a} then {set value "BERR"}
        :modify DPP[set CH]CSR :value $value
        if {$ViewMode == 0} {:modify INUSE :value [expr !(($value >> 7) & 1)]}

}

proc do_Chredisplay {ch} {
    global ViewMode modulename module

       if {$ViewMode == 0} then {set CH ""} else {set CH $ch}

        set value [read-vme-register $modulename#$module.Ch$ch.DPP_CSR]
        if {$value == 0x2000a} then {set value "BERR"}
        :modify DPP[set CH]CSR :value $value
        if {$ViewMode == 0} {:modify INUSE :value [expr !(($value >> 7) & 1)]}

        set value [read-vme-register $modulename#$module.Ch$ch.DPP_Wptr]
        if {$value == 0x2000a} then {set value "BERR"}
        :modify DPP[set CH]WPTR :value $value

        set value [read-vme-register $modulename#$module.Ch$ch.DPP_Rptr]
        if {$value == 0x2000a} then {set value "BERR"}
        :modify DPP[set CH]RPTR :value $value

        set value [read-vme-register $modulename#$module.Ch$ch.DPP_Reg4]
        if {$value == 0x2000a} then {set value "BERR"}
        if {$ViewMode != 0} {:modify DPP[set CH]4 :value $value}

        set value [read-vme-register $modulename#$module.Ch$ch.DPP_Reg5]
        if {$value == 0x2000a} then {set value "BERR"}
        :modify DPP[set CH]5 :value $value

        set value [read-vme-register $modulename#$module.Ch$ch.DPP_Reg6]
        if {$value == 0x2000a} then {set value "BERR"}
        :modify DPP[set CH]6 :value [expr $value]

        set value [read-vme-register $modulename#$module.Ch$ch.ADC_PreTrig]
        if {$value == 0x2000a} then {set value "BERR"}
        :modify ADC[set CH]PRETRIG :value [expr $value]

        set value [read-vme-register $modulename#$module.Ch$ch.ADC_Header]
        if {$value == 0x2000a} then {set value "BERR"}
        :modify ADC[set CH]HEADER :value $value

        set value [read-vme-register $modulename#$module.Ch$ch.ADC_Trigger]
        if {$value == 0x2000a} then {set value "BERR"}
        :modify ADC[set CH]TRIGGER :value $value
        if {$ViewMode == 0} {:modify ADCTRIGGERREG :value $value}

        set value [read-vme-register $modulename#$module.Ch$ch.ADC_Ctrl]
        if {$value == 0x2000a} then {set value "BERR"}
        :modify ADC[set CH]CTRL :value $value
        if {$ViewMode == 0} {:modify ADCCTRLREG :value $value}

        set value [read-vme-register $modulename#$module.Ch$ch.ADC_Spare3]
        if {$value == 0x2000a} then {set value "BERR"}
        if {$ViewMode != 0} {:modify ADC[set CH]ADCVERSION :value $value}

        set value [read-vme-register $modulename#$module.Ch$ch.ADC_CFDThresh]
        if {$value == 0x2000a} then {set value "BERR"}
        :modify ADC[set CH]CFDTHRESH :value [expr $value]

}

proc click-redisplay {} {
    global ViewMode modulename module
    global EGallow EGreport CurrentVMEServer
    global channel

    :modify MODULE-NUM :value $module
    set CurrentVMEServer [inform vmecontrol VMEmodule2server $modulename#$module]

    set EGreport_SAVE $EGreport
    set EGreport -1
    set-busy

    set EGallow 0x2000a

    if {$ViewMode == 0} {    ;# user Mode
        do_Chredisplay $channel
     } else {                 ;#  expert Mode
        foreach CH [list A B C D] {do_Chredisplay $CH}
     }

    set EGallow 0xffffffff

    clear-busy
    set EGreport $EGreport_SAVE
}

proc get-modulelist {} {
    global modulelist
    return $modulelist
}

proc mwd_parameters {ch} {
    global module modulename
    inform MWD start $modulename $module $ch
}

proc click arg {
   global debug actionlist allmodules allchannels channel
   if {$debug} then {puts insert-debug "click with argument \{$arg\}"}
   set f [lindex $arg 0]
   set c [lindex $arg 1]
   set w [lindex $arg 2]
   set v [lindex $arg 3]
   set i [lindex $arg 4]
   if {$c==":quit"} then {click-quit; return}
   switch -glob $w {

      MODULE-SEL      -
      MODULE-NUM      {click-select-module $v}
      CHANNEL         {click-select-channel $v}

      ALLMODULES   {set allmodules $v}
      ALLCHANNELS  {set allchannels $v}

      ACTIONS  {
         set action [lindex $actionlist $i]
         eval [second $action]
      }

      READA       {read_fifo A}
      READB       {read_fifo B}
      READC       {read_fifo C}
      READD       {read_fifo D}

      MWDA        {mwd_parameters A}
      MWDB        {mwd_parameters B}
      MWDC        {mwd_parameters C}
      MWDD        {mwd_parameters D}
      MWD         {mwd_parameters $channel}

      ADCCTRLREG     {click-widget ADCCTRL $v}
      ADCTRIGGERREG  {click-widget ADCTRIGGER $v}
      INUSE          {click-inuse $v}

      DPP*   - 
      ADC*        {click-widget $w $v}

      ENGINEERING       {click-$v}

      default           {
           set p "click_[lowercase $w]"
           if {[info procs $p] == "$p"} then {$p} else {insert-debug "$arg"}
      }
   }
}

proc make-frame {} {make-user-frame}
proc change-to-user {} {make-user-frame; click-redisplay}
proc change-to-engineering {} {make-engineering-frame; click-redisplay}

proc make-engineering-frame {} {
   global env ViewMode actionlist module maxmodule modulelist maxadc rates
   global allchannels allmodules

set x 12c

   set ViewMode 1

  :frame [self frame-name] :label "[self frame-title] - Engineering View" :show-footer T \
      :icon-image "@$env(ICONHOME)/vme_module" \
      :icon-name "[self icon-title]" :resize F

   :panel MODULE :layout T :padx 10 :pady 10
      :layout H; :row-gap 10; :col-gap 10

      :number MODULE-NUM  :label "Module number:" :min 1 :max $maxmodule :w 5 :value $module
      :menubutton MODULE-SEL :label "select:" :strings $modulelist

      :hskip 100
      :checkbox ALLCHANNELS :label "Act on all channels" :value $allchannels
      :hskip 50
      :checkbox ALLMODULES  :label "Act on all modules"  :value $allmodules

    foreach ch {A B C D} {

      :next-row T
      :message M$ch :label "Channel $ch" :bold T
      :next-row T

      :text DATA$ch :label "Data FIFO" :w 8  :valuex $x :deaf T
      :button READ$ch :label "Read"
      :button MWD$ch :label "MWD Parameters"
      :next-row T

      :text DPP[set ch]CSR  :label "DPP CSR"  :w 8 :valuex $x
      :text DPP[set ch]WPTR :label "DPP Write Ptr"  :w 8 :valuex $x
      :text DPP[set ch]RPTR :label "DPP Read Ptr"  :w 8 :valuex $x
      :text DPP[set ch]4    :label "DPP Version" :w 8 :valuex $x
      :text DPP[set ch]5    :label "DPP Reg 5" :w 8 :valuex $x
      :text DPP[set ch]6    :label "DPP Reg 6" :w 8 :valuex $x
      :next-row T

      :text ADC[set ch]CTRL            :label "ADC CTRL"     :w 8 :valuex $x
      :text ADC[set ch]PRETRIG         :label "ADC Pretrig"  :w 8 :valuex $x
      :text ADC[set ch]HEADER          :label "ADC Header"   :w 8 :valuex $x
      :text ADC[set ch]TRIGGER         :label "ADC Trigger"  :w 8 :valuex $x
      :text ADC[set ch]ADCVERSION      :label "ADC Version"  :w 8 :valuex $x
      :text ADC[set ch]CFDTHRESH       :label "CFD Thresh"   :w 8 :valuex $x
    }

   :panel CLICK :layout T :padx 10
      :layout H; :col-gap 25

      :button REDISPLAY   :command click-redisplay
      :button SWITCH   :label "Change to User view"  :command change-to-user
      :menubutton ENGINEERING :label "Engineering"  :menu [list software]

   :show T
}

proc make-user-frame {} {
   global env ViewMode actionlist module maxmodule modulelist maxadc rates
   global allchannels allmodules
   upvar #0 channel ch

set x 12c

   set ViewMode 0

  :frame [self frame-name] :label "[self frame-title] - User View" :show-footer T \
      :icon-image "@$env(ICONHOME)/vme_module" \
      :icon-name "[self icon-title]" :resize F

   :panel MODULE :layout T :padx 10 :pady 10
      :layout H; :row-gap 10; :col-gap 20

      :number MODULE-NUM  :label "Module number:" :min 1 :max $maxmodule :w 5 :value $module
      :menubutton MODULE-SEL :label "select:" :strings $modulelist

      :choice CHANNEL :label "Channel" :strings [list A B C D] :value [lsearch [list A B C D] $ch]
      :checkbox INUSE :label "In Use"

      :checkbox ALLCHANNELS :label "Act on all channels" :value $allchannels
      :checkbox ALLMODULES  :label "Act on all modules"  :value $allmodules

      :col-gap 10
      :next-row T

      :text DPPCSR  :label "DPP CSR"  :w 8 :valuex $x
      :text DPPWPTR :label "DPP Write Ptr"  :w 8 :valuex $x
      :text DPPRPTR :label "DPP Read Ptr"  :w 8 :valuex $x
      :text DPP5    :label "MWD Order" :w 8 :valuex $x
      :text DPP6    :label "Trace Length" :w 8 :valuex $x
      :next-row T

      :text ADCCTRL            :label "ADC CTRL"     :w 8 :valuex $x
      :text ADCPRETRIG         :label "ADC Pretrig"  :w 8 :valuex $x
      :text ADCHEADER          :label "ADC Header"   :w 8 :valuex $x
      :text ADCTRIGGER         :label "ADC Trigger"  :w 8 :valuex $x
      :text ADCCFDTHRESH       :label "CFD Thresh"   :w 8 :valuex $x

   :panel REGISTERS :layout T :padx 10
      :layout V; :row-gap 10; :col-gap 10

      :choice ADCCTRLREG  :label "ADC CTRL" :exclusive F :valuex 10c :layout V :w 60 \
         :strings [list "Soft Reset Control" "enable channel (if in use)" "timestamp counters: 0=ignore input gate; 1=reset by input gate (see next)" \
               "gate polarity for timestamp reset: 0=gate inactive; 1=gate active" "counter increment: 0=all triggers; 1=only accepted triggers" \
               "Front panel Trigger Out: 0=trigger out; 1=busy/inhibit" "inhibit/busy output polarity (Ch D only): 0=normal; 1=invert"  \
               "allow triggers when trigger gate polarity: 0=inactive; 1=active" \
               "trapezoid energy baseline subtraction disable" "digital gain control bit 0" "digital gain control bit 1"]

       :vskip 25
       :choice XXX :label "legend" :layout V :exclusive F :w 60 :strings [list "this bit is 0/off/false" "this bit is 1/on/true"] :value 2 :inactive T

        :next-col

      :choice ADCTRIGGERREG :label "ADC Trigger"  :exclusive F :valuex 12c :layout V :w 50 \
         :strings [list "Trigger Source: on=internal; off=front panel" "edge detection: on=rising edge; off=falling edge" \
              "mark data with pileup bit" "" "" "" "" "" "gate input: 0=ignored; 1=must be active to allow triggers" \
              "Cross channel trigger accept (when ADC CTRL bit 5 = 1)" "Trigger out generation option" "" \
                        "accept trigger from Ch A" "accept trigger from Ch B" "accept trigger from Ch C" "accept trigger from Ch D" ]

   :panel CLICK :layout T :padx 10
      :layout H; :col-gap 25

      :button REDISPLAY   :command click-redisplay
      :button MWD  :label "MWD Parameters"
      :button SWITCH   :label "Change to Engineering view"  :command change-to-engineering

   :show T
}

