#    most of this task is now taken from the standard application

set VERSION "GRT4P"

#    put some default environment variables before loading common 

if {[info exists env(VMEServer)]} then {set resource $env(VMEServer)} else {set resource VME}
set VMEserver $resource

if {[info exists env(RDOUTserver)]} then {set resource $env(RDOUTserver)} else {set resource VME}
set RDOUTserver $resource

set RDOUTserverList $RDOUTserver
set SpectrumServerList {}
set SpectrumServer [first $SpectrumServerList]

set DAProgram MIDASExecV2

loadsource  sys.common

proc checkinstallation  {} {return 0}       ;#   suppress check at present

set frametitle "MIDAS Data Acquisition Experiment Control (GRT4P)"


set VMEPresent 1
set VMEEnable 1

set TSPresent 1
set TSEnable 0
set txEnable 0

set histEnable 1
set HistMode 1

set TestBuffer ""

lappend Supported_Modules GRT

set S9418_Base 64
set Options(s9418_GroupBase) $S9418_Base

set V785_Base 80
set V775_Base 96
set Options(v785_GroupBase) $V785_Base
set Options(v775_GroupBase) $V775_Base

set UseGroup 0
set Options(UseGroup) $UseGroup

update_Options

loadsource sys.DA     ;#  for common data acquisition support

loadsource sys.2D    ;# for 2D histogrammming feature 


proc Custom_PreSetup {args} {define_VME_addresses}


set scantable 0
set usetime 0
set usecount 0
set verbose 0
set timerange 100

proc do_scantable {w v} {
    global scantable
 
    set scantable [expr $v*2]
    execute-command 16 "" "$scantable 0 0 0 0 0" 2
}

proc do_option {w v} {
    global usetime usecount verbose timerange

    switch $w {
        VERBOSE   {set verbose $v}
        USETIME   {set usetime $v}
        USECOUNT  {set usecount $v}
        TIMERANGE {set timerange $v}
    }

    execute-command 17 "" "$verbose $usetime $usecount $timerange" 2
}

proc do_clearstats {} {execute-command 7  "Clear Statistics"}

proc enable_scanning {} {execute-command 16 "" "3 1 2 3 4 5" 2}

proc click-histenable {v} {
    global RDOUThdwre RDOUTEnable histEnable
    if {$RDOUTEnable == 0} then {set  histEnable 0} else {set histEnable $v}
    if {$RDOUTEnable != 0} then {write-register NetVar.DACQ.Chistenable [expr $histEnable * 10]}
    redisplay-histenable
}
